#!/usr/bin/perl

sub sizer {
  my $fn = $ENV{'targd'} . '/' . shift;
  my @S = stat ($fn);
  return '' unless (@S && $S[7]);
  my $sz = $S[7] / 1024;
  $sz = ($sz < 1000 ? sprintf ('%.0fk', $sz) : sprintf ('%.1fM', $sz/1024));
  return " ($sz)";

}

while (<>) {
  s{(<a href=)([A-Za-z0-9\-\_\.]+\.dvi)(>[A-Za-z0-9\.\s]+)(</a>)}{"$1$2$3".&sizer($2).$4}egi;
  s{(<a href=)([A-Za-z0-9\-\_\.]+\.ps)(>[A-Za-z0-9\.\s]+)(</a>)}{"$1$2$3".&sizer($2).$4}egi;
  s{(<a href=)([A-Za-z0-9\-\_\.]+\.gz)(>[A-Za-z0-9\.\s]+)(</a>)}{"$1$2$3".&sizer($2).$4}egi;
  s{(<a href=)([A-Za-z0-9\-\_\.]+\.bz2)(>[A-Za-z0-9\.\s]+)(</a>)}{"$1$2$3".&sizer($2).$4}egi;
  print $_;
}
